SketchUp C API

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Related Functions
SUSectionPlaneRef Struct Reference

A sectionPlane entity reference. More...

`#include <SketchUpAPI/model/section_plane.h>`

Inherits SUDrawingElementRef.

## Related Functions
(Note that these are not member functions.)
SUEntityRef | SUSectionPlaneToEntity (SUSectionPlaneRef sectionPlane)
| Converts from an SUSectionPlaneRef to an SUEntityRef. This is essentially an upcast operation. More...
SUSectionPlaneRef | SUSectionPlaneFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUSectionPlaneRef. This is essentially a downcast operation so the given SUEntityRef must be convertible to an SUSectionPlaneRef. More...
SUDrawingElementRef | SUSectionPlaneToDrawingElement (SUSectionPlaneRef sectionPlane)
| Converts from an SUSectionPlaneRef to an SUDrawingElementRef. This is essentially an upcast operation. More...
SUSectionPlaneRef | SUSectionPlaneFromDrawingElement (SUDrawingElementRef drawing_elem)
| Converts from an SUDrawingElementRef to an SUSectionPlaneRef. This is essentially a downcast operation so the given element must be convertible to an SUSectionPlaneRef. More...
enum SUResult | SUSectionPlaneCreate (SUSectionPlaneRef *sectionPlane)
| Creates an sectionPlane object. The sectionPlane object must be subsequently deallocated with SUSectionPlaneRelease() unless it is associated with a parent object. The plane is initialized as an xy plane and can be changed with the SUSectionPlaneSetPlane(). More...
enum SUResult | SUSectionPlaneRelease (SUSectionPlaneRef *sectionPlane)
| Releases a sectionPlane object. The sectionPlane object must have been created with SUSectionPlaneCreate() and not subsequently associated with a parent object (e.g. SUEntitiesRef). More...
enum SUResult | SUSectionPlaneSetPlane (SUSectionPlaneRef sectionPlane, const struct SUPlane3D *plane)
| Sets the plane of the section plane. More...
enum SUResult | SUSectionPlaneGetPlane (SUSectionPlaneRef sectionPlane, struct SUPlane3D *plane)
| Retrieves the plane of the section plane. More...
enum SUResult | SUSectionPlaneIsActive (SUSectionPlaneRef sectionPlane, bool *is_active)
| Retrieves a boolean indicating whether or not the section plane is active. More...
enum SUResult | SUSectionPlaneGetName (SUSectionPlaneRef sectionPlane, SUStringRef *name)
| Retrieves the name of a section plane object. More...
enum SUResult | SUSectionPlaneSetName (SUSectionPlaneRef sectionPlane, const char *name)
| Sets the name of a section plane object. More...
enum SUResult | SUSectionPlaneGetSymbol (SUSectionPlaneRef sectionPlane, SUStringRef *symbol)
| Retrieves the symbol of a section plane object. The symbol is used in the Outliner and in the section display in the model. For example, you might have several sections on the same area of a building all named "South West Section" and use symbols to differenciate each section, "01", "02", "03". More...
enum SUResult | SUSectionPlaneSetSymbol (SUSectionPlaneRef sectionPlane, const char *symbol)
| Sets the symbol of a section plane object. More...
Related Functions inherited from SUDrawingElementRef
SUEntityRef | SUDrawingElementToEntity (SUDrawingElementRef elem)
| Converts from an SUDrawingElementRef to an SUEntityRef. This is essentially an upcast operation. More...
SUDrawingElementRef | SUDrawingElementFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUDrawingElementRef. This is essentially a downcast operation so the given entity must be convertible to a drawing element. More...
enum SURefType | SUDrawingElementGetType (SUDrawingElementRef elem)
| Returns the concrete type of the given drawing element. More...
enum SUResult | SUDrawingElementGetBoundingBox (SUDrawingElementRef elem, struct SUBoundingBox3D *bbox)
| Retrieves the bounding box of a drawing element. More...
enum SUResult | SUDrawingElementGetMaterial (SUDrawingElementRef elem, SUMaterialRef *material)
| Retrieves the material object of a drawing element. More...
enum SUResult | SUDrawingElementSetMaterial (SUDrawingElementRef elem, SUMaterialRef material)
| Sets the material of a drawing element. More...
enum SUResult | SUDrawingElementGetLayer (SUDrawingElementRef elem, SULayerRef *layer)
| Retrieves the layer object associated with a drawing element. More...
enum SUResult | SUDrawingElementSetLayer (SUDrawingElementRef elem, SULayerRef layer)
| Sets the layer object to be associated with a drawing element. More...
enum SUResult | SUDrawingElementSetHidden (SUDrawingElementRef elem, bool hide_flag)
| Sets the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementGetHidden (SUDrawingElementRef elem, bool *hide_flag)
| Retrieves the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementSetCastsShadows (SUDrawingElementRef elem, bool casts_shadows_flag)
| Sets the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetCastsShadows (SUDrawingElementRef elem, bool *casts_shadows_flag)
| Retrieves the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementSetReceivesShadows (SUDrawingElementRef elem, bool receives_shadows_flag)
| Sets the receives shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetReceivesShadows (SUDrawingElementRef elem, bool *receives_shadows_flag)
| Retrieves the receives shadows flag of a drawing element. More...
Related Functions inherited from SUEntityRef
enum SURefType | SUEntityGetType (SUEntityRef entity)
| Returns the concrete type of the given entity. More...
enum SUResult | SUEntityGetID (SUEntityRef entity, int32_t *entity_id)
| Retrieves the id of the entity. More...
enum SUResult | SUEntityGetPersistentID (SUEntityRef entity, int64_t *entity_pid)
| Retrieves the persistent id of the entity. More...
enum SUResult | SUEntityGetNumAttributeDictionaries (SUEntityRef entity, size_t *count)
| Retrieves the number of attribute dictionaries of an entity. More...
enum SUResult | SUEntityGetAttributeDictionaries (SUEntityRef entity, size_t len, SUAttributeDictionaryRef dictionaries[], size_t *count)
| Retrieves the attribute dictionaries of an entity. More...
enum SUResult | SUEntityAddAttributeDictionary (SUEntityRef entity, SUAttributeDictionaryRef dictionary)
| Adds the attribute dictionary to an entity. The given dictionary object must not belong to another entity. In other words, each dictionary should be added to one entity only. More...
enum SUResult | SUEntityGetAttributeDictionary (SUEntityRef entity, const char *name, SUAttributeDictionaryRef *dictionary)
| Retrieves the attribute dictionary of an entity that has the given name. More...
enum SUResult | SUEntityGetModel (SUEntityRef entity, SUModelRef *model)
| Retrieves the model object associated with the entity. More...
enum SUResult | SUEntityGetParentEntities (SUEntityRef entity, SUEntitiesRef *entities)
| Retrieves the entities object which contains the entity. More...

## Detailed Description

A sectionPlane entity reference.

Since
  SketchUp 2016, API 4.0

## Friends And Related Function Documentation

enum SUResult SUSectionPlaneCreate | ( | SUSectionPlaneRef * | sectionPlane | ) |
| related

Creates an sectionPlane object. The sectionPlane object must be subsequently deallocated with SUSectionPlaneRelease() unless it is associated with a parent object. The plane is initialized as an xy plane and can be changed with the SUSectionPlaneSetPlane().

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | sectionPlane | The sectionPlane object.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_NULL_POINTER_INPUT if sectionPlane is NULL
  - SU_ERROR_OVERWRITE_VALID if sectionPlane references a valid object

SUSectionPlaneRef SUSectionPlaneFromDrawingElement | ( | SUDrawingElementRef | drawing_elem | ) |
| related

Converts from an SUDrawingElementRef to an SUSectionPlaneRef. This is essentially a downcast operation so the given element must be convertible to an SUSectionPlaneRef.

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | drawing_elem | The given element reference.

Returns
  - The converted SUSectionPlaneRef if the downcast operation succeeds
  - If not, the returned reference will be invalid.

SUSectionPlaneRef SUSectionPlaneFromEntity | ( | SUEntityRef | entity | ) |
| related

Converts from an SUEntityRef to an SUSectionPlaneRef. This is essentially a downcast operation so the given SUEntityRef must be convertible to an SUSectionPlaneRef.

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | entity | The entity object.

Returns
  - The converted SUSectionPlaneRef if the downcast operation succeeds
  - If the downcast operation fails, the returned reference will be invalid

enum SUResult SUSectionPlaneGetName | ( | SUSectionPlaneRef | sectionPlane,
|  | SUStringRef * | name
| ) |  |
| related

Retrieves the name of a section plane object.

Since
  SketchUp 2018, API 6.0

Parameters

  [in] | sectionPlane | The section plane object.
  [out] | name | The name retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if sectionPlane is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if name is NULL
  - SU_ERROR_INVALID_OUTPUT if name does not point to a valid SUStringRef object

enum SUResult SUSectionPlaneGetPlane | ( | SUSectionPlaneRef | sectionPlane,
|  | struct SUPlane3D * | plane
| ) |  |
| related

Retrieves the plane of the section plane.

Parameters

  [in] | sectionPlane | The sectionPlane object.
  [out] | plane | The 3d plane retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if sectionPlane is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if plane is NULL

enum SUResult SUSectionPlaneGetSymbol | ( | SUSectionPlaneRef | sectionPlane,
|  | SUStringRef * | symbol
| ) |  |
| related

Retrieves the symbol of a section plane object. The symbol is used in the Outliner and in the section display in the model. For example, you might have several sections on the same area of a building all named "South West Section" and use symbols to differenciate each section, "01", "02", "03".

Since
  SketchUp 2018, API 6.0

Parameters

  [in] | sectionPlane | The section plane object.
  [out] | symbol | The symbol retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if sectionPlane is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if symbol is NULL
  - SU_ERROR_INVALID_OUTPUT if symbol does not point to a valid SUStringRef object

enum SUResult SUSectionPlaneIsActive | ( | SUSectionPlaneRef | sectionPlane,
|  | bool * | is_active
| ) |  |
| related

Retrieves a boolean indicating whether or not the section plane is active.

Parameters

  [in] | sectionPlane | The sectionPlane object.
  [out] | is_active | Returns true if the section plane is active.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if sectionPlane is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if is_active is NULL

enum SUResult SUSectionPlaneRelease | ( | SUSectionPlaneRef * | sectionPlane | ) |
| related

Releases a sectionPlane object. The sectionPlane object must have been created with SUSectionPlaneCreate() and not subsequently associated with a parent object (e.g. SUEntitiesRef).

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | sectionPlane | The sectionPlane object.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_NULL_POINTER_INPUT if sectionPlane is NULL
  - SU_ERROR_INVALID_INPUT if sectionPlane does not reference a valid object

enum SUResult SUSectionPlaneSetName | ( | SUSectionPlaneRef | sectionPlane,
|  | const char * | name
| ) |  |
| related

Sets the name of a section plane object.

Since
  SketchUp 2018, API 6.0

Parameters

  [in] | sectionPlane | The section plane object.
  [in] | name | The string to set as the section plane name. Assumed to be UTF-8 encoded. An example of a name would be "South West Section" for the section on the south west side of a building.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if sectionPlane is not a valid object
  - SU_ERROR_NULL_POINTER_INPUT if name is NULL

enum SUResult SUSectionPlaneSetPlane | ( | SUSectionPlaneRef | sectionPlane,
|  | const struct SUPlane3D * | plane
| ) |  |
| related

Sets the plane of the section plane.

Parameters

  [in] | sectionPlane | The sectionPlane object.
  [in] | plane | The 3d plane to be set.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if sectionPlane is not a valid object
  - SU_ERROR_NULL_POINTER_INPUT if plane is NULL

enum SUResult SUSectionPlaneSetSymbol | ( | SUSectionPlaneRef | sectionPlane,
|  | const char * | symbol
| ) |  |
| related

Sets the symbol of a section plane object.

Since
  SketchUp 2018, API 6.0

Parameters

  [in] | sectionPlane | The section plane object.
  [in] | symbol | The string to set as the section plane symbol. Assumed to be UTF-8 encoded. The maximum number of characters is 3.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if sectionPlane is not a valid object
  - SU_ERROR_INVALID_INPUT if symbol is greater than three characters long
  - SU_ERROR_NULL_POINTER_INPUT if symbol is NULL

SUDrawingElementRef SUSectionPlaneToDrawingElement | ( | SUSectionPlaneRef | sectionPlane | ) |
| related

Converts from an SUSectionPlaneRef to an SUDrawingElementRef. This is essentially an upcast operation.

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | sectionPlane | The given sectionPlane reference.

Returns
  - The converted SUEntityRef if sectionPlane is a valid sectionPlane
  - If not, the returned reference will be invalid

SUEntityRef SUSectionPlaneToEntity | ( | SUSectionPlaneRef | sectionPlane | ) |
| related

Converts from an SUSectionPlaneRef to an SUEntityRef. This is essentially an upcast operation.

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | sectionPlane | The sectionPlane object.

Returns
  - The converted SUEntityRef if sectionPlane is a valid object
  - If not, the returned reference will be invalid

The documentation for this struct was generated from the following files:

- SketchUpAPI/model/defs.h
- SketchUpAPI/model/section_plane.h